import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGoods, ThinkGoodsParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkGoods(params: ThinkGoodsParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGoods>>>(
    THINK_API_URL + '/think/think-goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkGoods(params?: ThinkGoodsParam) {
  const res = await request.get<ApiResult<ThinkGoods[]>>(
    THINK_API_URL + '/think/think-goods',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkGoods(data: ThinkGoods) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkGoods(data: ThinkGoods) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkGoods(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkGoods(id: number) {
  const res = await request.get<ApiResult<ThinkGoods>>(
    THINK_API_URL + '/think/think-goods/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
